← All operations
POST/api/v1/admin/staking/policies

Growth_PublishStakeTierPolicy

Authentication
required-admin
Cache policy
none
Success and errors
201, 400, 401, 403, 404, 409, 500, 503
Stability
v1 stable contract

OpenAPI operation

{
  "operationId": "Growth_PublishStakeTierPolicy",
  "summary": "POST /api/v1/admin/staking/policies",
  "tags": [
    "Growth"
  ],
  "parameters": [
    {
      "name": "Idempotency-Key",
      "in": "header",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid"
      }
    }
  ],
  "requestBody": {
    "required": true,
    "content": {
      "application/json": {
        "schema": {
          "type": "object",
          "properties": {
            "assetId": {
              "type": "string",
              "format": "uuid",
              "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
            },
            "evaluationKind": {
              "default": "MINIMUM_DURATION",
              "type": "string",
              "enum": [
                "CURRENT_LOCKED",
                "TIME_WEIGHTED",
                "MINIMUM_DURATION"
              ]
            },
            "evaluationWindowSeconds": {
              "anyOf": [
                {
                  "type": "integer",
                  "exclusiveMinimum": 0,
                  "maximum": 315360000
                },
                {
                  "type": "null"
                }
              ]
            },
            "explanationMarkdown": {
              "type": "string",
              "minLength": 20,
              "maxLength": 100000
            },
            "effectiveFrom": {
              "type": "string",
              "format": "date-time",
              "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
            },
            "rules": {
              "minItems": 1,
              "maxItems": 50,
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "tierCode": {
                    "type": "string",
                    "pattern": "^[A-Z][A-Z0-9_]{1,31}$"
                  },
                  "minimumUnits": {
                    "type": "string",
                    "pattern": "^(?:0|[1-9][0-9]{0,77})$"
                  },
                  "minimumRemainingSeconds": {
                    "type": "integer",
                    "minimum": 0,
                    "maximum": 315360000
                  },
                  "multiplierPpm": {
                    "type": "integer",
                    "minimum": 0,
                    "maximum": 10000000
                  }
                },
                "required": [
                  "tierCode",
                  "minimumUnits",
                  "minimumRemainingSeconds",
                  "multiplierPpm"
                ],
                "additionalProperties": false
              }
            },
            "benefits": {
              "default": [],
              "maxItems": 200,
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "tierCode": {
                    "type": "string",
                    "pattern": "^[A-Z][A-Z0-9_]{1,31}$"
                  },
                  "benefitCode": {
                    "type": "string",
                    "pattern": "^[A-Z][A-Z0-9._:-]{1,119}$"
                  },
                  "effect": {
                    "type": "string",
                    "enum": [
                      "ENTITLEMENT",
                      "DISCOUNT_BPS",
                      "REFERRAL_MULTIPLIER_PPM",
                      "BOUNTY_FEE_SHARE_BPS",
                      "LAUNCH_FEE_SHARE_BPS"
                    ]
                  },
                  "integerValue": {
                    "anyOf": [
                      {
                        "type": "string",
                        "pattern": "^(?:0|[1-9][0-9]{0,77})$"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "textValue": {
                    "anyOf": [
                      {
                        "type": "string",
                        "maxLength": 500
                      },
                      {
                        "type": "null"
                      }
                    ]
                  }
                },
                "required": [
                  "tierCode",
                  "benefitCode",
                  "effect"
                ],
                "additionalProperties": false
              }
            },
            "reason": {
              "type": "string",
              "minLength": 10,
              "maxLength": 4000
            },
            "dryRun": {
              "default": true,
              "type": "boolean"
            },
            "confirmation": {
              "type": "string",
              "maxLength": 500
            }
          },
          "required": [
            "assetId",
            "explanationMarkdown",
            "rules",
            "reason"
          ],
          "additionalProperties": false
        }
      }
    }
  },
  "security": [
    {
      "cookieAuth": []
    }
  ],
  "responses": {
    "201": {
      "description": "Success",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "additionalProperties": false,
            "required": [
              "data",
              "meta"
            ],
            "properties": {
              "data": {
                "type": "object",
                "properties": {
                  "applied": {
                    "type": "boolean"
                  },
                  "confirmation": {
                    "type": "string"
                  },
                  "id": {
                    "type": "string",
                    "format": "uuid",
                    "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
                  },
                  "version": {
                    "type": "integer",
                    "exclusiveMinimum": 0,
                    "maximum": 9007199254740991
                  }
                },
                "required": [
                  "applied",
                  "confirmation",
                  "id",
                  "version"
                ],
                "additionalProperties": false
              },
              "meta": {
                "type": "object",
                "additionalProperties": true,
                "required": [
                  "requestId",
                  "schemaVersion",
                  "buildVersion",
                  "generatedAt",
                  "freshness"
                ],
                "properties": {
                  "requestId": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "schemaVersion": {
                    "type": "string"
                  },
                  "buildVersion": {
                    "type": "string"
                  },
                  "generatedAt": {
                    "type": "string",
                    "format": "date-time"
                  },
                  "freshness": {
                    "type": "object",
                    "additionalProperties": false,
                    "required": [
                      "projectedAt",
                      "sourceWatermark"
                    ],
                    "properties": {
                      "projectedAt": {
                        "type": [
                          "string",
                          "null"
                        ],
                        "format": "date-time"
                      },
                      "sourceWatermark": {
                        "type": [
                          "string",
                          "null"
                        ]
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "400": {
      "description": "invalid request",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "401": {
      "description": "unauthenticated",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "403": {
      "description": "forbidden",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "404": {
      "description": "not found",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "409": {
      "description": "conflict",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "500": {
      "description": "internal error",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "503": {
      "description": "dependency unavailable",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    }
  },
  "x-auth-mode": "required-admin",
  "x-cache-policy": "none",
  "x-required-scopes": [],
  "x-rate-cost": 1,
  "x-stability": "STABLE"
}